diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/core/trusted.h metacity-2.27.1/src/core/trusted.h
--- ../metacity-2.27.1/src/core/trusted.h	1970-01-01 01:00:00.000000000 +0100
+++ metacity-2.27.1/src/core/trusted.h	2009-09-14 09:05:34.526276684 +0200
@@ -0,0 +1,206 @@
+/* Metacity trusted */
+
+/* 
+ * Copyright (C) 2005 Erwann Chenede
+ */
+
+#ifndef TRUSTED_H
+#define TRUSTED_H
+
+#ifdef HAVE_XTSOL
+#include "frames.h"
+#include "display.h"
+#include "display-private.h"
+#include "theme.h"
+#include <gdk/gdkcolor.h>
+#include <gtk/gtk.h>
+#include "trusted-pics.h"
+#include <X11/extensions/Xtsol.h>
+#include <sys/tsol/label_macro.h>
+/* #include "constraint-scaling.h" */
+
+typedef struct _ConstraintImage ConstraintImage;
+struct _ConstraintImage
+{
+  gchar     *filename;
+  GdkPixbuf *pixbuf;
+  GdkPixbuf *scaled;
+  gboolean   stretch;
+  gint       border_left;
+  gint       border_right;
+  gint       border_bottom;
+  gint       border_top;
+  guint      hints[3][3];
+  gboolean   recolorable;
+  GdkColor   colorize_color;
+  gboolean   use_as_bkg_mask;
+};
+
+/* dlopened libtsol functions */
+
+typedef int     (*tsol_label_to_str) (const m_label_t *label, char **string,
+				      const m_label_str_t conversion_type, uint_t flags,
+				      int *error);
+typedef int	(*tsol_str_to_label) (const char *string, m_label_t **label,
+				      const m_label_type_t label_type, uint_t flags,
+				      int *error);
+typedef void	(*tsol_m_label_free) (m_label_t *label);
+
+typedef blrange_t*  (*tsol_getuserrange) (const char *username);
+typedef int	    (*tsol_blinrange)	 (const m_label_t *label,
+					  const blrange_t *range);
+typedef void	    (*tsol_blminimum)	 (m_label_t *minimum_label,
+					  const m_label_t *bounding_label);
+typedef void	    (*tsol_blmaximum)	 (m_label_t *maximum_label,
+					  const m_label_t *bounding_label);
+typedef m_label_t*  (*tsol_blabel_alloc) (void);
+typedef void	    (*tsol_blabel_free)  (m_label_t *label_p);
+typedef void	    (*tsol_bsllow)	 (m_label_t *label);
+typedef void	    (*tsol_bslhigh)	 (m_label_t *label);
+
+
+typedef void  (*gnome_tsol_constraint_image_render) (ConstraintImage *cimage,
+						     GdkWindow    *window,
+						     GdkBitmap    *mask,
+						     GdkRectangle *clip_rect,
+						     gboolean      center,		   
+						     gint          x,
+						     gint          y,
+						     gint          width,
+						     gint          height);
+
+typedef void (*gnome_tsol_constraint_image_set_border) (ConstraintImage *pb,
+							gint         left,
+							gint         right,
+							gint         top,
+							gint         bottom);
+
+typedef void (*gnome_tsol_constraint_image_set_stretch) (ConstraintImage *pb,
+							 gboolean     stretch);
+
+typedef void (*gnome_tsol_constraint_image_colorize) (ConstraintImage *image,
+						      GdkColor  *color,
+						      int	alpha,
+						      gboolean   use_alpha);
+
+/* dlopened libXtsol functions */
+typedef Status	(*xtsol_XTSOLgetClientLabel) (Display *dpy, 
+					      XID xid,
+					      bslabel_t *sl);
+typedef Bool    (*xtsol_XTSOLIsWindowTrusted) (Display *dpy, 
+					       Window win);
+
+typedef Status (*xtsol_XTSOLsetResLabel) (Display *dpy,
+					  XID object,
+					  ResourceType resourceFlag,
+					  bslabel_t *sl);
+typedef Status (*xtsol_XTSOLsetResUID) (Display *dpy,
+					XID object,
+					ResourceType resourceFlag,
+					uid_t *uidp);
+
+typedef Status (*xtsol_XTSOLgetResLabel) (Display *dpy,
+					   XID object,
+					   ResourceType resourceFlag,
+					   bslabel_t *sl);
+
+typedef Status (*xtsol_XTSOLgetResUID) (Display *dpy,
+					XID object,
+					ResourceType resourceFlag,
+					uid_t *uidp);
+
+/* libbsm provides getdevicerange(3TSOL) - don't believe the man page */
+typedef blrange_t*      (*bsm_getdevicerange) (const char *device);
+
+
+tsol_label_to_str	libtsol_label_to_str;
+tsol_str_to_label	libtsol_str_to_label;
+tsol_m_label_free	libtsol_m_label_free;
+tsol_blminimum		libtsol_blminimum;
+tsol_blmaximum		libtsol_blmaximum;
+tsol_blinrange		libtsol_blinrange;
+tsol_getuserrange	libtsol_getuserrange;
+tsol_blabel_alloc	libtsol_blabel_alloc;
+tsol_blabel_free	libtsol_blabel_free;
+tsol_bsllow		libtsol_bsllow;
+tsol_bslhigh		libtsol_bslhigh;
+/* libbsm functions */
+bsm_getdevicerange      libbsm_getdevicerange;
+
+gnome_tsol_constraint_image_render libgnome_tsol_constraint_image_render;
+gnome_tsol_constraint_image_set_border libgnome_tsol_constraint_image_set_border;
+gnome_tsol_constraint_image_set_stretch libgnome_tsol_constraint_image_set_stretch;
+gnome_tsol_constraint_image_colorize libgnome_tsol_constraint_image_colorize;
+
+xtsol_XTSOLgetClientLabel	libxtsol_XTSOLgetClientLabel;
+xtsol_XTSOLIsWindowTrusted	libxtsol_XTSOLIsWindowTrusted;
+
+xtsol_XTSOLsetResLabel		libxtsol_XTSOLsetResLabel;
+xtsol_XTSOLgetResLabel		libxtsol_XTSOLgetResLabel;
+xtsol_XTSOLsetResUID		libxtsol_XTSOLsetResUID;
+xtsol_XTSOLgetResUID		libxtsol_XTSOLgetResUID;
+
+gboolean tsol_is_available (void);
+gboolean tsol_use_trusted_extensions (void);
+
+/* metacity trusted functions */
+
+struct _MetaTrustedLabel 
+{
+  char		*name;
+  PangoLayout	*layout;
+  MetaColorSpec *color;
+};
+
+void		      tsol_trusted_stripe_atom_update (MetaDisplay *display, 
+						       MetaWindow  *window);
+
+MetaDrawOpList*	      tsol_theme_trusted_label_ops_get (MetaFrameFocus focus,
+							MetaTheme *theme);
+MetaDrawOpList*	      tsol_theme_trusted_title_ops_get (MetaFrameFocus focus,
+							MetaTheme *theme);
+
+MetaTrustedLabel*     tsol_meta_window_label_get (MetaWindow  *window);
+MetaTrustedLabel*     tsol_workspace_get_label (MetaWorkspace *ws);
+MetaTrustedLabel*     tsol_xwindow_label_get (MetaDisplay *display, 
+					      Window	   xwindow);
+
+gboolean tsol_should_label_layout_be_black (MetaColorSpec *bkg);
+gboolean tsol_meta_workspace_has_role (MetaWorkspace *ws);
+char * tsol_meta_workspace_get_role (MetaWorkspace *ws);
+
+
+gboolean tsol_meta_window_can_move_to_workspace (MetaWindow    *win,
+						 MetaWorkspace *ws);
+
+gboolean tsol_xwindow_can_move_to_workspace (Display *display,
+					     Window   xwin,
+					     int      ws_index);
+
+gboolean tsol_meta_screen_use_roles (MetaScreen *screen);
+GList*	 tsol_add_all_sticky_non_tp_windows (MetaDisplay *display,
+					     GList	 *win_list);
+
+void tsol_workspace_labels_atom_set (MetaScreen *screen);
+void tsol_workspace_roles_atom_set (MetaScreen *screen);
+
+	
+void tsol_workspace_labels_gconf_update (MetaScreen *screen);
+void tsol_workspace_roles_gconf_update (MetaScreen *screen);
+
+gboolean	tsol_label_is_in_user_range (const char * label);
+const char     *tsol_label_get_min ();
+const char     *tsol_label_get_max ();
+
+gboolean tsol_label_is_in_role_range (const char * label, 
+				      const char * username, 
+				      char *min_role_label);
+
+ConstraintImage * tsol_get_highlight_stripe (char     *name,
+					     GdkColor *label_color);
+
+void tsol_set_frame_label (Display* xdpy, Window xwin, Window xwin_frame);
+
+
+#endif /*HAVE_XTSOL*/
+#endif /*TRUSTED_H*/
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/core/window.c metacity-2.27.1/src/core/window.c
--- ../metacity-2.27.1/src/core/window.c	2009-09-14 09:05:19.279629271 +0200
+++ metacity-2.27.1/src/core/window.c	2009-09-14 09:05:34.528960194 +0200
@@ -45,6 +45,7 @@
 #include "constraints.h"
 #include "compositor.h"
 #include "effects.h"
+#include "frames.h"
 
 #include <X11/Xatom.h>
 #include <string.h>
@@ -759,6 +760,10 @@ meta_window_new_with_attrs (MetaDisplay 
   meta_stack_add (window->screen->stack, 
                   window);
 
+
+  if (window->decorated)
+    meta_window_ensure_frame (window);
+
   /* Put our state back where it should be,
    * passing TRUE for is_configure_request, ICCCM says
    * initial map is handled same as configure request
@@ -1325,6 +1330,17 @@ gboolean
 meta_window_located_on_workspace (MetaWindow    *window,
                                   MetaWorkspace *workspace)
 {
+#ifdef HAVE_XTSOL
+  if (tsol_meta_workspace_has_role (workspace))
+    {
+      /* SUN_BRANDING TJDS */
+      if (window->on_all_workspaces && window->decorated && strcmp (tsol_meta_window_label_get (window)->name, _("Trusted Path")) != 0)
+	{
+	  /* printf ("meta_window_visible_on_workspace in ws role win (%s) is not TP\n", window->title); */
+	  return FALSE;
+	}
+    }
+#endif  
   return (window->on_all_workspaces && window->screen == workspace->screen) ||
     (window->workspace == workspace);
 }
@@ -1764,7 +1780,12 @@ meta_window_queue (MetaWindow *window, g
               G_PRIORITY_DEFAULT_IDLE   /* UPDATE_ICON */
             };
 
-          const GSourceFunc window_queue_idle_handler[NUMBER_OF_QUEUES] =
+	  /* removing the const definition as the trusted patch 
+	   * includes this file in libmetacity_private. Which 
+	   * cause linker errors due to 
+	   * "relocations remain against allocatable but non-writable sections"
+	   * Better solution welcome */
+          GSourceFunc window_queue_idle_handler[NUMBER_OF_QUEUES] =
             {
               idle_calc_showing,
               idle_move_resize,
@@ -3274,8 +3295,14 @@ meta_window_move_resize_internal (MetaWi
               old_rect.x, old_rect.y, old_rect.width, old_rect.height);
   
   if (window->frame)
-    meta_frame_calc_geometry (window->frame,
-                              &fgeom);
+    {
+      meta_frame_calc_geometry (window->frame,
+				&fgeom);
+#ifdef HAVE_XTSOL      
+      if (tsol_is_available ()) /*Trusted Frame Layout Modification TFLM*/
+	fgeom.top_height += fgeom.top_height; 
+#endif /* HAVE_XTSOL */      
+    }
 
   new_rect.x = root_x_nw;
   new_rect.y = root_y_nw;
@@ -4206,6 +4233,11 @@ void
 meta_window_change_workspace (MetaWindow    *window,
                               MetaWorkspace *workspace)
 {
+#ifdef HAVE_XTSOL  
+  if (!tsol_meta_window_can_move_to_workspace(window, workspace))
+    return;
+#endif
+    
   meta_window_change_workspace_without_transients (window, workspace);
 
   meta_window_foreach_transient (window, change_workspace_foreach,
@@ -5334,16 +5366,17 @@ meta_window_notify_focus (MetaWindow *wi
               GList* link;
               link = g_list_find (window->screen->active_workspace->mru_list, 
                                   window);
-              g_assert (link);
-
-              window->screen->active_workspace->mru_list = 
-                g_list_remove_link (window->screen->active_workspace->mru_list,
-                                    link);
-              g_list_free (link);
-
-              window->screen->active_workspace->mru_list = 
-                g_list_prepend (window->screen->active_workspace->mru_list, 
-                                window);
+ 	      if (link)
+ 		{
+ 		  window->screen->active_workspace->mru_list =
+ 		    g_list_remove_link (window->screen->active_workspace->mru_list,
+ 					link);
+ 		  g_list_free (link);
+ 		  
+ 		  window->screen->active_workspace->mru_list = 
+ 		    g_list_prepend (window->screen->active_workspace->mru_list,                                 
+ 				    window);		  
+ 		}
             }
 
           if (window->frame)
@@ -6536,6 +6569,17 @@ meta_window_show_menu (MetaWindow *windo
 
   if (!window->on_all_workspaces)
     {
+#ifdef HAVE_XTSOL
+       if (layout.current_col > 0 && tsol_meta_window_can_move_to_workspace (window, meta_workspace_get_neighbor (window->screen->active_workspace, META_MOTION_LEFT)))
+         ops |= META_MENU_OP_MOVE_LEFT;
+       if (layout.current_col < layout.cols - 1 && tsol_meta_window_can_move_to_workspace (window, meta_workspace_get_neighbor (window->screen->active_workspace, META_MOTION_RIGHT)))
+         ops |= META_MENU_OP_MOVE_RIGHT;
+       if (layout.current_row > 0 && tsol_meta_window_can_move_to_workspace (window, meta_workspace_get_neighbor (window->screen->active_workspace, META_MOTION_UP)))
+         ops |= META_MENU_OP_MOVE_UP;
+       if (layout.current_row < layout.rows - 1 && tsol_meta_window_can_move_to_workspace (window, meta_workspace_get_neighbor (window->screen->active_workspace, META_MOTION_DOWN)))
+         ops |= META_MENU_OP_MOVE_DOWN;
+#else
+
       ltr = meta_ui_get_direction() == META_UI_DIRECTION_LTR;
 
       if (layout.current_col > 0)
@@ -6548,6 +6592,7 @@ meta_window_show_menu (MetaWindow *windo
       if ((layout.current_row < layout.rows - 1) &&
           ((layout.current_row + 1) * layout.cols + layout.current_col < n_workspaces))
         ops |= META_MENU_OP_MOVE_DOWN;
+#endif      
     }
 
   meta_screen_free_workspace_layout (&layout);
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/core/workspace.c metacity-2.27.1/src/core/workspace.c
--- ../metacity-2.27.1/src/core/workspace.c	2009-09-14 09:05:19.272956814 +0200
+++ metacity-2.27.1/src/core/workspace.c	2009-09-14 09:05:34.529419808 +0200
@@ -120,6 +120,10 @@ meta_workspace_free (MetaWorkspace *work
    */
   
   tmp = workspace->windows;
+#ifdef HAVE_XTSOL
+  if (tsol_is_available ())
+    tmp = tsol_add_all_sticky_non_tp_windows (workspace->screen->display, tmp);
+#endif /*HAVE_XTSOL*/
   while (tmp != NULL)
     {
       GList *next;
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/include/prefs.h metacity-2.27.1/src/include/prefs.h
--- ../metacity-2.27.1/src/include/prefs.h	2009-09-14 09:05:19.284626019 +0200
+++ metacity-2.27.1/src/include/prefs.h	2009-09-14 09:06:26.278136474 +0200
@@ -31,6 +31,10 @@
 
 typedef enum
 {
+#ifdef HAVE_XTSOL
+  META_PREF_WORKSPACE_LABELS,
+  META_PREF_WORKSPACE_ROLES,
+#endif /*HAVE_XTSOL*/
   META_PREF_MOUSE_BUTTON_MODS,
   META_PREF_FOCUS_MODE,
   META_PREF_FOCUS_NEW_WINDOWS,
@@ -117,6 +121,15 @@ int         meta_prefs_get_cursor_size  
 gboolean    meta_prefs_get_compositing_manager (void);
 gboolean    meta_prefs_get_force_fullscreen  (void);
 
+#ifdef HAVE_XTSOL
+const char* meta_prefs_get_workspace_label    (int         i);
+void        meta_prefs_change_workspace_label (int         i,
+                                              const char *name);
+const char* meta_prefs_get_workspace_role    (int         i);
+void        meta_prefs_change_workspace_role (int         i,
+                                              const char *name);
+#endif /* HAVE_XTSOL */
+
 /**
  * Sets whether the compositor is turned on.
  *
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/include/ui.h metacity-2.27.1/src/include/ui.h
--- ../metacity-2.27.1/src/include/ui.h	2009-09-14 09:05:19.285511276 +0200
+++ metacity-2.27.1/src/include/ui.h	2009-09-14 09:05:34.530226877 +0200
@@ -204,6 +205,12 @@ MetaUIDirection meta_ui_get_direction (v
 
 GdkPixbuf *meta_ui_get_pixbuf_from_pixmap (Pixmap   pmap);
 
+#ifdef HAVE_XTSOL
+void    meta_ui_set_frame_label  (MetaUI           *ui,
+                                  Window            xwindow,
+                                  MetaTrustedLabel *label);
+#endif
+
 #include "tabpopup.h"
 
 #endif
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/include/window.h metacity-2.27.1/src/include/window.h
--- ../metacity-2.27.1/src/include/window.h	2009-09-14 09:05:19.285454771 +0200
+++ metacity-2.27.1/src/include/window.h	2009-09-14 09:05:34.530426272 +0200
@@ -27,6 +27,8 @@
 
 #include "boxes.h"
 #include "types.h"
+#include <pango/pango.h>
+#include "theme.h"
 
 MetaFrame *meta_window_get_frame (MetaWindow *window);
 gboolean meta_window_has_focus (MetaWindow *window);
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/ui/frames.c metacity-2.27.1/src/ui/frames.c
--- ../metacity-2.27.1/src/ui/frames.c	2009-09-14 09:05:19.282740664 +0200
+++ metacity-2.27.1/src/ui/frames.c	2009-09-14 09:05:34.531413653 +0200
@@ -606,7 +606,7 @@ meta_frames_manage_window (MetaFrames *f
 
   g_assert (window);
 
-  frame = g_new (MetaUIFrame, 1);
+  frame = g_new0 (MetaUIFrame, 1);
   
   frame->window = window;
 
@@ -2491,7 +2491,14 @@ meta_frames_paint_to_drawable (MetaFrame
       /* Punch out the client area */
 
       area.x = left;
+#ifdef HAVE_XTSOL  
+      if (tsol_is_available ())
+	area.y = top + top; /*Trusted Frame Layout Modification TFLM*/
+      else
+	area.y = top;
+#else  
       area.y = top;
+#endif  
       area.width = w;
       area.height = h;
       tmp_region = gdk_region_rectangle (&area);
@@ -2537,7 +2544,11 @@ meta_frames_paint_to_drawable (MetaFrame
             frame->text_height,
             &button_layout,
             button_states,
-            mini_icon, icon);
+            mini_icon, icon
+#ifdef HAVE_XTSOL			     
+	    ,frame->label
+#endif				    
+	    );
 
           gdk_window_end_paint (drawable);
         }
@@ -2563,7 +2574,11 @@ meta_frames_paint_to_drawable (MetaFrame
                                         frame->text_height,
                                         &button_layout,
                                         button_states,
-                                        mini_icon, icon);
+                                        mini_icon, icon
+#ifdef HAVE_XTSOL			     
+					,frame->label
+#endif					
+					);
     }
 
 }
@@ -2937,3 +2952,26 @@ invalidate_whole_window (MetaFrames *fra
   gdk_window_invalidate_rect (frame->window, NULL, FALSE);
   invalidate_cache (frames, frame);
 }
+
+#ifdef HAVE_XTSOL
+void
+meta_frames_set_label (MetaFrames *frames,
+                       Window      xwindow,
+                       MetaTrustedLabel *label)
+{
+  GtkWidget *widget;
+  MetaUIFrame *frame;
+  
+  widget = GTK_WIDGET (frames);
+
+  frame = meta_frames_lookup_window (frames, xwindow);
+
+  g_assert (frame);
+
+  if (frame->label != NULL)
+    g_warning ("label should be null");
+
+  frame->label = label;
+}
+#endif
+
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/ui/frames.h metacity-2.27.1/src/ui/frames.h
--- ../metacity-2.27.1/src/ui/frames.h	2009-09-14 09:05:19.281220132 +0200
+++ metacity-2.27.1/src/ui/frames.h	2009-09-14 09:05:34.531705969 +0200
@@ -28,6 +28,9 @@
 #include <gdk/gdkx.h>
 #include "common.h"
 #include "theme.h"
+#ifdef HAVE_XTSOL
+#include "trusted.h"
+#endif
 
 typedef enum
 {
@@ -77,6 +80,9 @@ struct _MetaUIFrame
   GdkWindow *window;
   GtkStyle *style;
   MetaFrameStyle *cache_style;
+#ifdef HAVE_XTSOL  
+  MetaTrustedLabel *label;
+#endif  
   PangoLayout *layout;
   int text_height;
   char *title; /* NULL once we have a layout */
@@ -160,4 +166,9 @@ Window meta_frames_get_moving_frame (Met
 void meta_frames_push_delay_exposes (MetaFrames *frames);
 void meta_frames_pop_delay_exposes  (MetaFrames *frames);
 
+#ifdef HAVE_XTSOL
+void meta_frames_set_label (MetaFrames	     *frames, 
+			    Window	      xwindow,
+			    MetaTrustedLabel *label);
+#endif
 #endif
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/ui/preview-widget.c metacity-2.27.1/src/ui/preview-widget.c
--- ../metacity-2.27.1/src/ui/preview-widget.c	2009-09-14 09:05:19.282363565 +0200
+++ metacity-2.27.1/src/ui/preview-widget.c	2009-09-14 09:05:34.532049000 +0200
@@ -25,6 +25,7 @@
 #define _XOPEN_SOURCE 600 /* for the maths routines over floats */
 
 #include <math.h>
+#include <config.h>
 #include <gtk/gtk.h>
 #include "preview-widget.h"
 
@@ -262,7 +263,13 @@ meta_preview_expose (GtkWidget      *wid
                              &preview->button_layout,
                              button_states,
                              meta_preview_get_mini_icon (),
-                             meta_preview_get_icon ());
+                             meta_preview_get_icon ()
+#ifdef BUILD_TX_CODE
+#ifdef HAVE_XTSOL                           
+                            ,NULL
+#endif                      
+#endif                      
+                              );
     }
 
   /* draw child */
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/ui/tabpopup.c metacity-2.27.1/src/ui/tabpopup.c
--- ../metacity-2.27.1/src/ui/tabpopup.c	2009-09-14 09:05:19.282510314 +0200
+++ metacity-2.27.1/src/ui/tabpopup.c	2009-09-14 09:05:34.532552518 +0200
@@ -35,6 +35,10 @@
 #include "draw-workspace.h"
 #include <gtk/gtk.h>
 #include <math.h>
+#ifdef HAVE_XTSOL
+#include "trusted.h"
+#include "../core/display-private.h"
+#endif /* HAVE_XTSOL */
 
 #define OUTSIDE_SELECT_RECT 2
 #define INSIDE_SELECT_RECT 2
@@ -103,6 +107,65 @@ outline_window_expose (GtkWidget      *w
   return FALSE;
 }
 
+#ifdef HAVE_XTSOL 
+static gboolean should_label_layout_be_black (GdkColor *color)
+{
+  int ntsc;
+  ntsc = ((color->red) * .4450 +
+	   (color->blue) * .030 +
+	   (color->green) * .525);
+
+  if ((65535 - ntsc) < .61 * 65535)
+      return TRUE;
+  return FALSE;
+}
+
+static gboolean
+tsol_tab_label_expose_event (GtkWidget      *widget,
+			     GdkEventExpose *event,
+			     gpointer        data)
+{
+  MetaTabPopup *popup;
+  int w, h;
+  TabEntry *te;  
+  ConstraintImage *cimage;
+  MetaTrustedLabel *tlabel;
+
+  popup = data;
+
+  if (popup->current_selected_entry == NULL)
+    return FALSE;
+  
+  te = popup->current_selected_entry;
+
+  if (popup->outline)
+    tlabel = tsol_xwindow_label_get (meta_display_for_x_display (gdk_display), (Window) te->key);
+  else
+    tlabel = tsol_workspace_get_label ((MetaWorkspace *) te->key);
+
+  if (should_label_layout_be_black (&tlabel->color->data.basic.color))
+    gtk_widget_modify_fg (widget, GTK_STATE_NORMAL, &widget->style->black);
+  else
+    gtk_widget_modify_fg (widget, GTK_STATE_NORMAL, &widget->style->white);
+  
+
+  cimage = tsol_get_highlight_stripe (tlabel->name, &tlabel->color->data.basic.color);
+
+  if (cimage)
+    libgnome_tsol_constraint_image_render (cimage, 
+					   widget->window,    
+					   NULL, &event->area,
+					   FALSE,
+					   event->area.x,
+					   event->area.y,
+					   event->area.width,
+					   event->area.height);
+
+   return FALSE;
+}
+#endif /* HAVE_XTSOL */
+
+
 static GdkPixbuf*
 dimm_icon (GdkPixbuf *pixbuf)
 {
@@ -303,6 +366,13 @@ meta_ui_tab_popup_new (const MetaTabEntr
 
   gtk_box_pack_end (GTK_BOX (vbox), popup->label, FALSE, FALSE, 0);
 
+#ifdef HAVE_XTSOL
+  if (tsol_is_available ())
+    g_signal_connect (G_OBJECT (popup->label), "expose_event",
+		      G_CALLBACK (tsol_tab_label_expose_event),
+		      popup);
+#endif /*HAVE_XTSOL */  
+
   max_label_width = 0;
   top = 0;
   bottom = 1;
@@ -943,6 +1013,34 @@ meta_select_workspace_expose_event (GtkW
         }
     }
 
+#ifdef HAVE_XTSOL  
+  if (tsol_is_available ())
+    {
+      GdkGC *tmp_gc = gdk_gc_new (widget->window);
+      MetaTrustedLabel *label = tsol_workspace_get_label (workspace);
+      
+      gdk_gc_set_rgb_fg_color (tmp_gc, &label->color->data.basic.color);
+     
+      gdk_draw_rectangle (widget->window,
+			  tmp_gc,
+			  TRUE,
+			  widget->allocation.width / 3,
+			  0,
+			  widget->allocation.width / 3,
+			  4);
+
+      g_object_unref (tmp_gc);
+      
+      gdk_draw_rectangle (widget->window,
+			  widget->style->black_gc,
+			  FALSE,
+			  widget->allocation.width / 3,
+			  0,
+			  widget->allocation.width / 3,
+			  4);
+    }
+#endif /*HAVE_XTSOL*/  
+
   return TRUE;
 }
 
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/ui/theme-viewer.c metacity-2.27.1/src/ui/theme-viewer.c
--- ../metacity-2.27.1/src/ui/theme-viewer.c	2009-09-14 09:05:19.282935189 +0200
+++ metacity-2.27.1/src/ui/theme-viewer.c	2009-09-14 09:05:34.533018972 +0200
@@ -1009,7 +1009,11 @@ run_theme_benchmark (void)
                              &button_layout,
                              button_states,
                              meta_preview_get_mini_icon (),
-                             meta_preview_get_icon ());
+                             meta_preview_get_icon ()
+#ifdef HAVE_XTSOL			     
+			     ,NULL
+#endif			     
+			    );
 
       g_object_unref (G_OBJECT (pixmap));
       
